﻿Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition
Imports System.Collections.ObjectModel
Imports System.IO
Imports System.Runtime.Serialization
Imports System.Runtime.Serialization.Formatters.Binary
Imports Microsoft.SqlServer.Types
<Serializable()>
Public Class Form1
   Private moSQLLayer As MsSql2008FeatureLayer
   Private moLayerOverlay As LayerOverlay
   Private Const USA_Contiguous_Albers_Equal_Area_Conic As Integer = 102003
   Private Const csSerializePath As String = "..\..\Sample Files\"
   Private msLayerName As String

   Private Sub LoadSQLSpatialLayer()
      Dim sConnect As String = "Data Source=STEVEM6500\WOOFPUPPY;Initial Catalog=BaseData;Integrated Security=True;User ID=;Password="
      Dim oAreaStyle As AreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.SimpleColors.Blue, 1, LineDashStyle.Solid, 0, 0)
      Dim sKeyField As String = "PLSSectionKey"

      '***** Here is the view vw_BaseData_PLSSections
      'CREATE View [dbo].[vw_BaseData_PLSSections]
      'AS
      'Select p.PLSSectionKey, p.[StateAbbreviation], p.[StateName], p.CountyName, p.TRS, pm.PrincipleMeridianID, 
      '	p.SEC, p.TWP, p.TDIR, p.RNG, p.RDIR, pm.PMText, p.SHAPE  
      'from PLSSection p
      'Join PRINCIPLEMERIDIAN pm on pm.PrincipleMeridianID = p.MER

      If rbOpenView.Checked Then
         msLayerName = "vw_BaseData_PLSSections"
      Else
         msLayerName = "PLSSection"
      End If

      moSQLLayer = New MsSql2008FeatureLayer(sConnect, msLayerName, sKeyField, USA_Contiguous_Albers_Equal_Area_Conic)
      moSQLLayer.CustomGeometryColumnName = "shape"

      Dim oMap As WinformsMap = WinformsMap1

      moLayerOverlay = New LayerOverlay
      oMap.Overlays.Add(msLayerName, moLayerOverlay)

      moSQLLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = oAreaStyle
      moSQLLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
      moSQLLayer.Name = msLayerName
      moLayerOverlay.Layers.Add(moSQLLayer.Name, moSQLLayer)

      oMap.Refresh()

   End Sub

   Private Sub btnLoad_Click(sender As System.Object, e As System.EventArgs) Handles btnLoad.Click
      LoadSQLSpatialLayer()
   End Sub


   Private Sub btnSerialize_Click(sender As Object, e As EventArgs) Handles btnSerialize.Click
      Dim sFilename As String = msLayerName + ".xml"

      moSQLLayer.Close()
      Dim oSerializer As New GeoSerializer
      Using oStream As New FileStream(csSerializePath + sFilename, FileMode.Create, FileAccess.Write)
         oSerializer.Serialize(moSQLLayer, oStream)
         moLayerOverlay.Layers.Remove(msLayerName)
         oSerializer = Nothing
      End Using

      WinformsMap1.Refresh()


   End Sub

   Private Sub btnDeSerialize_Click(sender As Object, e As EventArgs) Handles btnDeSerialize.Click
      Dim sFilename As String = msLayerName + ".xml"
      Dim o As Object
      Dim oSerializer As New GeoSerializer()
      o = oSerializer.Deserialize(csSerializePath + sFilename, FileAccess.Read)
      moSQLLayer = CType(o, MsSql2008FeatureLayer)
      moLayerOverlay.Layers.Add(msLayerName, moSQLLayer)
      WinformsMap1.Refresh 
      oSerializer = Nothing

   End Sub

   Private Sub rbOpenView_CheckedChanged(sender As Object, e As EventArgs) Handles rbOpenView.CheckedChanged, rbOpenTable.CheckedChanged
      If rbOpenView.Checked Then
         msLayerName = "vw_BaseData_PLSSections"
      Else
         msLayerName = "PLSSection"
      End If
   End Sub

   Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
      WinformsMap1.MapUnit = GeographyUnit.Meter
      Dim oExtent As New RectangleShape(734111.84247961, -617201.296395542, 761629.15638026, -632851.768676537)
      WinformsMap1.CurrentExtent = oExtent

   End Sub

   Private Sub btnDeserializeFrom8_Click(sender As Object, e As EventArgs) Handles btnDeserializeFrom8.Click
      Dim sFilename As String = msLayerName + "_ver8.xml"
      Dim o As Object
      Dim oSerializer As New GeoSerializer()
      o = oSerializer.Deserialize(csSerializePath + sFilename, FileAccess.Read)
      moSQLLayer = CType(o, MsSql2008FeatureLayer)
      moLayerOverlay.Layers.Add(msLayerName, moSQLLayer)
      WinformsMap1.Refresh()
      oSerializer = Nothing

   End Sub
End Class
